# coding: utf-8

"""
    Corva Data API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError

from typing_extensions import Annotated
from pydantic import Field, StrictStr, conint

from typing import List, Optional

from corva_data_dataset.models.corva_dataset import CorvaDataset

from corva_data_dataset.api_client import ApiClient
from corva_data_dataset.api_response import ApiResponse
from corva_data_dataset.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class CorvaDatasetApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def find_data_provider_dataset(self, provider : StrictStr, dataset : StrictStr, limit : Annotated[conint(strict=True, le=10000, ge=1), Field(..., description="Maximum number of results to return")], query : Annotated[StrictStr, Field(..., description="Search conditions")], sort : Annotated[StrictStr, Field(..., description="Sort conditions")], skip : Annotated[Optional[conint(strict=True, ge=0)], Field(description="Number of records to skip (default: 0)")] = None, fields : Annotated[Optional[StrictStr], Field(description="Comma separated list of fields to return")] = None, **kwargs) -> List[CorvaDataset]:  # noqa: E501
        """Find Data  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.find_data_provider_dataset(provider, dataset, limit, query, sort, skip, fields, async_req=True)
        >>> result = thread.get()

        :param provider: (required)
        :type provider: str
        :param dataset: (required)
        :type dataset: str
        :param limit: Maximum number of results to return (required)
        :type limit: int
        :param query: Search conditions (required)
        :type query: str
        :param sort: Sort conditions (required)
        :type sort: str
        :param skip: Number of records to skip (default: 0)
        :type skip: int
        :param fields: Comma separated list of fields to return
        :type fields: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: List[CorvaDataset]
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the find_data_provider_dataset_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.find_data_provider_dataset_with_http_info(provider, dataset, limit, query, sort, skip, fields, **kwargs)  # noqa: E501

    @validate_arguments
    def find_data_provider_dataset_with_http_info(self, provider : StrictStr, dataset : StrictStr, limit : Annotated[conint(strict=True, le=10000, ge=1), Field(..., description="Maximum number of results to return")], query : Annotated[StrictStr, Field(..., description="Search conditions")], sort : Annotated[StrictStr, Field(..., description="Sort conditions")], skip : Annotated[Optional[conint(strict=True, ge=0)], Field(description="Number of records to skip (default: 0)")] = None, fields : Annotated[Optional[StrictStr], Field(description="Comma separated list of fields to return")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Find Data  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.find_data_provider_dataset_with_http_info(provider, dataset, limit, query, sort, skip, fields, async_req=True)
        >>> result = thread.get()

        :param provider: (required)
        :type provider: str
        :param dataset: (required)
        :type dataset: str
        :param limit: Maximum number of results to return (required)
        :type limit: int
        :param query: Search conditions (required)
        :type query: str
        :param sort: Sort conditions (required)
        :type sort: str
        :param skip: Number of records to skip (default: 0)
        :type skip: int
        :param fields: Comma separated list of fields to return
        :type fields: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(List[CorvaDataset], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'provider',
            'dataset',
            'limit',
            'query',
            'sort',
            'skip',
            'fields'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method find_data_provider_dataset" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['provider']:
            _path_params['provider'] = _params['provider']

        if _params['dataset']:
            _path_params['dataset'] = _params['dataset']


        # process the query parameters
        _query_params = []
        if _params.get('skip') is not None:  # noqa: E501
            _query_params.append(('skip', _params['skip']))

        if _params.get('limit') is not None:  # noqa: E501
            _query_params.append(('limit', _params['limit']))

        if _params.get('fields') is not None:  # noqa: E501
            _query_params.append(('fields', _params['fields']))

        if _params.get('query') is not None:  # noqa: E501
            _query_params.append(('query', _params['query']))

        if _params.get('sort') is not None:  # noqa: E501
            _query_params.append(('sort', _params['sort']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['APIKeyHeader', 'HTTPBearer']  # noqa: E501

        _response_types_map = {
            '200': "List[CorvaDataset]",
            '401': "HTTPValidationError",
            '403': "HTTPValidationError",
            '422': "HTTPValidationError",
        }

        return self.api_client.call_api(
            '/api/v1/data/{provider}/{dataset}/', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
